#!/bin/sh
OUT=out.$$
INDEX=index.$$
LOG=LOG.$$
THEMES=themes$$.phtml

cleanup()
{
	rm -f $OUT $INDEX $LOG $THEMES
}


get_one_theme()
{
 rm -f download
 wget --proxy=on -N "$1"  >$OUT 2>&1
 tail -2 $OUT | sed -n 1p 
}

if [ "$#" -gt 1 ] || ( [ "$#" -eq 1 ] &&  [ "$1" != "-gen" ] ); then
 echo use as $0 '[-gen]' >&2
 echo "\"-gen\" switch will just generate the list of themes' urls"
 exit 1
fi
if [ "`type -path wget`" = "" ]; then
 echo you need to have wget installed >&2
 exit 1
fi
echo "trying to find the number of themes... " >&2
wget --proxy=on http://gtk.themes.org/themes.phtml -O $THEMES > $LOG  2>&1
if [ $? -ne 0 ] || [ ! -e $THEMES ]; then
  echo 'failed to get http://gtk.themes.org/themes.phtml' >&2
  cd ..
  cleanup
  exit 1
fi
N=`sed -n '/theme search - [0123456789][0123456789]* themes from a total/{
s/.*theme search - [0123456789][0123456789]* themes from a total of *\([0123456789][0123456789]*\) .*/\1/
p
}' $THEMES`
if [ -z "$N" ]; then
 echo 'failed to get the number; the page format probably has changed' >&2
 cleanup
 exit 1
fi
echo $N total themes >&2
echo -n "extracting themes' links... " >&2
rm -f $THEMES
wget --proxy=on "http://gtk.themes.org/themes.phtml?action=search&themetxt=&submit=Search&odby=download&disptype=norm&numthemes=$N&showmod=off" -O $THEMES > $LOG  2>&1
if [ $? -ne 0 ] || [ ! -e $THEMES ]; then
  echo failed to get "http://gtk.themes.org/themes.phtml?action=search&themetxt=&submit=Search&odby=download&disptype=norm&numthemes=$N&showmod=off" >&2
  cd ..
  cleanup
  exit 1
fi
grep '>Quick</a>' $THEMES |cut -f2 -d '(' | cut -f1 -d ')' \
	| cut -f2 -d "\""> $INDEX
echo done >&2
if [ "$1" = "-gen" ]; then
 sed 's/\(.*\)/http:\/\/gtk.themes.org\1/' $INDEX
 cleanup
 exit 0
fi
echo downloading themes one by one... >&2
LINE=""
( cat $INDEX && echo EOF ) | \
{
  read LINE
  while [ "$LINE" != EOF ]
  do
    get_one_theme "http://gtk.themes.org$LINE"
    read LINE
  done
}
cleanup
